%global momorel 1

Name: httpd

### include local configuration
%{?include_specopt}

%define contentdir /var/www
%{?!suexec_caller_user: %global suexec_caller_user apache}
%{?!suexec_caller_group: %global suexec_caller_group apache}
%{?!suexec_uidmin: %global suexec_uidmin 500}
%{?!suexec_gidmin: %global suexec_gidmin 500}
%{?!suexec_docroot: %global suexec_docroot %{contentdir}}
%define mmn 20051115
%define vstring Momonga
%define distro Momonga Linux

Summary: Apache HTTP Server
Version: 2.2.14
Release: %{momorel}m%{?dist}
URL: http://httpd.apache.org/
Source0: http://www.apache.org/dist/httpd/httpd-%{version}.tar.bz2
NoSource: 0
Source1: index.html
Source3: httpd.logrotate
Source4: httpd.init
Source5: httpd.sysconf
Source7: powered_by_momonga.png
Source8: error-messages.tar.bz2
Source10: httpd.conf
Source11: ssl.conf
Source12: welcome.conf
Source13: manual.conf
Source14: proxy_ajp.conf
Source15: mod_proxy.conf
Source16: mod_cache.conf
Source17: mod_dav.conf
Source18: mod_ldap.conf
# Documentation
Source30: migration.xml
Source31: migration.css
Source32: html.xsl
Source33: README.confd
# build/scripts patches
Patch1: httpd-2.1.10-apctl.patch
Patch2: httpd-2.1.10-apxs.patch
Patch3: httpd-2.2.9-deplibs.patch
Patch4: httpd-2.1.10-disablemods.patch
Patch5: httpd-2.1.10-layout.patch
# Features/functional changes
Patch20: httpd-2.0.48-release.patch
Patch21: httpd-2.2.11-xfsz.patch
Patch22: httpd-2.1.10-pod.patch
Patch23: httpd-2.0.45-export.patch
Patch24: httpd-2.2.11-corelimit.patch
Patch25: httpd-2.2.11-selinux.patch
Patch26: httpd-2.2.9-suenable.patch
# Bug fixes
Patch54: httpd-2.2.0-authnoprov.patch

# for Momonga layout
Patch60: httpd-2.2.4-momonga-layout.patch

License: Apache
Group: System Environment/Daemons
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: db4-devel, expat-devel, findutils, perl, pkgconfig
BuildRequires: xmlto >= 0.0.11
BuildRequires: apr-devel >= 1.2.8-3m
BuildRequires: apr-util-devel >= 1.3.4
BuildRequires: pcre-devel >= 5.0
BuildRequires: zlib-devel, libselinux-devel
Requires: /etc/mime.types, gawk, findutils
Obsoletes: httpd-suexec, httpd-apr, mod_auth_ldap
PreReq: chkconfig, mktemp, coreutils
PreReq: sh-utils, textutils, shadow-utils
Provides: webserver
Provides: httpd-mmn = %{mmn}
Obsoletes: apache, secureweb, mod_dav, mod_gzip
Obsoletes: stronghold-apache, stronghold-htdocs
Obsoletes: mod_put, mod_roaming, mod_jk
Conflicts: pcre < 4.0

%description
The Apache HTTP Server is a powerful, efficient, and extensible
web server.

%package devel
Group: Development/Libraries
Summary: Development tools for the Apache HTTP server.
Obsoletes: secureweb-devel, apache-devel, stronghold-apache-devel
Requires: apr-devel, apr-util-devel
Requires: httpd = %{version}-%{release}

%description devel
The httpd-devel package contains the APXS binary and other files
that you need to build Dynamic Shared Objects (DSOs) for the
Apache HTTP Server.

If you are installing the Apache HTTP server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package manual
Group: Documentation
Summary: Documentation for the Apache HTTP server.
Requires: httpd = %{version}-%{release}
Obsoletes: secureweb-manual, apache-manual

%description manual
The httpd-manual package contains the complete manual and
reference guide for the Apache HTTP server. The information can
also be found at http://httpd.apache.org/docs/2.2/.

%package -n mod_ssl
Group: System Environment/Daemons
Summary: SSL/TLS module for the Apache HTTP server
BuildRequires: openssl-devel, distcache-devel
Requires(post): openssl >= 0.9.7f-4, /bin/cat
Requires: httpd = %{version}-%{release}, httpd-mmn = %{mmn}
Obsoletes: stronghold-mod_ssl

%description -n mod_ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%prep
%setup -q
%patch1 -p1 -b .apctl
%patch2 -p1 -b .apxs
%patch3 -p1 -b .deplibs
%patch4 -p1 -b .disablemods
%patch5 -p1 -b .layout

%patch21 -p1 -b .xfsz
%patch22 -p1 -b .pod
%patch23 -p1 -b .export
%patch24 -p1 -b .corelimit
%patch25 -p1 -b .selinux
%patch26 -p1 -b .suenable

%patch54 -p1 -b .authnoprov

%patch60 -p1 -b .momonga

# Patch in vendor/release string
sed "s/@RELEASE@/%{vstring}/" < %{PATCH20} | patch -p1

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}.
   : Update the mmn macro and rebuild.
   exit 1
fi

: Building for '%{distro}' with MMN %{mmn} and vendor string '%{vstring}'

%build
# forcibly prevent use of bundled apr, apr-util, pcre
rm -rf srclib/{apr,apr-util,pcre}

# regenerate configure scripts
autoheader && autoconf || exit 1

## Limit size of CHANGES to recent history
#echo '1,/Changes with Apache MPM/wq' | ed CHANGES

# Before configure; fix location of build dir in generated apxs
%{__perl} -pi -e "s:\@exp_installbuilddir\@:%{_libdir}/httpd/build:g" \
	support/apxs.in
# update location of migration guide in apachectl
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
	support/apachectl.in

# Build the migration guide
sed 's/@DISTRO@/%{distro}/' < $RPM_SOURCE_DIR/migration.xml > migration.xml
xmlto -x $RPM_SOURCE_DIR/html.xsl html-nochunks migration.xml
cp $RPM_SOURCE_DIR/migration.css . # make %%doc happy

CFLAGS=$RPM_OPT_FLAGS
export CFLAGS

function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
../configure \
 	--prefix=%{_sysconfdir}/httpd \
 	--exec-prefix=%{_prefix} \
 	--bindir=%{_bindir} \
 	--sbindir=%{_sbindir} \
 	--mandir=%{_mandir} \
	--libdir=%{_libdir} \
	--sysconfdir=%{_sysconfdir}/httpd/conf \
	--includedir=%{_includedir}/httpd \
	--libexecdir=%{_libdir}/httpd/modules \
	--datadir=%{contentdir} \
        --with-installbuilddir=%{_libdir}/httpd/build \
	--with-mpm=$mpm \
        --with-apr=%{_prefix} --with-apr-util=%{_prefix} \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%{suexec_caller_user} \
	--with-suexec-docroot=%{suexec_docroot} \
	--with-suexec-logfile=%{_localstatedir}/log/httpd/suexec.log \
	--with-suexec-bin=%{_sbindir}/suexec \
	--with-suexec-uidmin=%{suexec_uidmin} --with-suexec-gidmin=%{suexec_gidmin} \
        --enable-pie \
        --with-pcre \
%if %{_lib} == "lib64"
        --enable-layout=Momonga64 \
%else
        --enable-layout=Momonga \
%endif
	$*

make %{?_smp_mflags} \
    prefix=%{_sysconfdir}/httpd \
    bindir=%{_bindir} \
    sbindir=%{_sbindir} \
    mandir=%{_mandir} \
    libdir=%{_libdir} \
    sysconfdir=%{_sysconfdir}/httpd/conf \
    includedir=%{_includedir}/httpd \
    libexecdir=%{_libdir}/httpd/modules \
    datadir=%{contentdir}

popd
}

# Build everything and the kitchen sink with the prefork build
mpmbuild prefork \
        --enable-mods-shared=all \
	--enable-ssl --with-ssl --enable-distcache \
	--enable-proxy \
        --enable-cache --enable-mem-cache \
        --enable-file-cache --enable-disk-cache \
        --enable-ldap --enable-authnz-ldap \
        --enable-cgid \
        --enable-authn-anon --enable-authn-alias

# For the other MPMs, just build httpd and no optional modules
mpmbuild worker --enable-modules=none
#mpmbuild event --enable-modules=none

%install
rm -rf %{buildroot}

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
mv docs/man/ab.8 docs/man/ab.1
mv docs/man/logresolve.8 docs/man/logresolve.1

pushd prefork
make DESTDIR=%{buildroot} install
popd

# install alternative MPMs
install -m 755 worker/httpd %{buildroot}%{_sbindir}/httpd.worker
#install -m 755 event/httpd %{buildroot}%{_sbindir}/httpd.event

# install conf file/directory
mkdir %{buildroot}%{_sysconfdir}/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/README.confd \
    %{buildroot}%{_sysconfdir}/httpd/conf.d/README

install -m 644 $RPM_SOURCE_DIR/welcome.conf %{buildroot}%{_sysconfdir}/httpd/conf.d/welcome.conf

for f in ssl.conf manual.conf proxy_ajp.conf mod_proxy.conf mod_cache.conf mod_dav.conf mod_ldap.conf; do
  install -m 644 $RPM_SOURCE_DIR/$f %{buildroot}%{_sysconfdir}/httpd/conf.d/$f.dist
done

rm %{buildroot}%{_sysconfdir}/httpd/conf/*.conf
install -m 644 $RPM_SOURCE_DIR/httpd.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

mkdir %{buildroot}%{_sysconfdir}/sysconfig
install -m 644 $RPM_SOURCE_DIR/httpd.sysconf \
   %{buildroot}%{_sysconfdir}/sysconfig/httpd

# for holding mod_dav lock database
mkdir -p %{buildroot}%{_localstatedir}/lib/dav

# create a prototype session cache
mkdir -p %{buildroot}%{_localstatedir}/cache/mod_ssl
touch %{buildroot}%{_localstatedir}/cache/mod_ssl/scache.{dir,pag,sem}

# create cache root
mkdir %{buildroot}%{_localstatedir}/cache/mod_proxy

# move utilities to /usr/bin
mv %{buildroot}%{_sbindir}/{ab,htdbm,logresolve,htpasswd,htdigest} \
   %{buildroot}%{_bindir}

# move builddir to the right place
#mv %{buildroot}%{contentdir}/build %{buildroot}%{_libdir}/httpd/build

# Make the MMN accessible to module packages
echo %{mmn} > %{buildroot}%{_includedir}/httpd/.mmn

# docroot
# mkdir %{buildroot}%{contentdir}/html
%{__tar} jxf %{SOURCE8} -C  %{buildroot}%{contentdir}
install -m 644 $RPM_SOURCE_DIR/index.html \
	%{buildroot}%{contentdir}/error/noindex.html

# remove manual sources
find %{buildroot}%{contentdir}/manual \( \
    -name \*.xml -o -name \*.xml.* -o -name \*.ent -o -name \*.xsl -o -name \*.dtd \
    \) -print0 | xargs -0 rm -f

# Strip the manual down just to English and replace the typemaps with flat files:
set +x
for f in `find %{buildroot}%{contentdir}/manual -name \*.html -type f`; do
   if test -f ${f}.en; then
      cp ${f}.en ${f}
      rm ${f}.*
   fi
done
set -x

install -m 644 $RPM_SOURCE_DIR/powered_by_momonga.png \
	%{buildroot}%{contentdir}/icons

# logs
# rmdir %{buildroot}%{_sysconfdir}/httpd/logs
mkdir -p %{buildroot}%{_localstatedir}/log/httpd

# symlinks for /etc/httpd
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}/etc/httpd/logs
ln -s ../..%{_localstatedir}/run %{buildroot}/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}/etc/httpd/modules
ln -s ../..%{_libdir}/httpd/build %{buildroot}/etc/httpd/build

# install SYSV init stuff
mkdir -p %{buildroot}/etc/init.d
install -m755 $RPM_SOURCE_DIR/httpd.init \
	%{buildroot}/etc/init.d/httpd
%{__perl} -pi -e "s:\@docdir\@:%{_docdir}/%{name}-%{version}:g" \
	%{buildroot}/etc/init.d/httpd	

# install log rotation stuff
mkdir -p %{buildroot}/etc/logrotate.d
install -m644 $RPM_SOURCE_DIR/httpd.logrotate \
	%{buildroot}/etc/logrotate.d/httpd

# fix man page paths
#sed -e "s|/usr/local/apache2/conf/httpd.conf|/etc/httpd/conf/httpd.conf|" \
#    -e "s|/usr/local/apache2/conf/mime.types|/etc/mime.types|" \
#    -e "s|/usr/local/apache2/conf/magic|/etc/httpd/conf/magic|" \
#    -e "s|/usr/local/apache2/logs/error_log|/var/log/httpd/error_log|" \
#    -e "s|/usr/local/apache2/logs/access_log|/var/log/httpd/access_log|" \
#    -e "s|/usr/local/apache2/logs/httpd.pid|/var/run/httpd.pid|" \
#    -e "s|/usr/local/apache2|/etc/httpd|" < docs/man/httpd.8 \
#  > %{buildroot}%{_mandir}/man8/httpd.8

# Remove unpackaged files
rm -f %{buildroot}%{_libdir}/*.exp \
      %{buildroot}/etc/httpd/conf/mime.types \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{_libdir}/httpd/build/config.nice \
      %{buildroot}%{_bindir}/ap?-config \
      %{buildroot}%{_sbindir}/{checkgid,dbmmanage,envvars*} \
      %{buildroot}%{contentdir}/htdocs/* \
      %{buildroot}%{_mandir}/man1/dbmmanage.* \
      %{buildroot}%{contentdir}/cgi-bin/*

rm -rf %{buildroot}/etc/httpd/conf/{original,extra}

# Make suexec a+rw so it can be stripped.  %%files lists real permissions
chmod 755 %{buildroot}%{_sbindir}/suexec

# delete unexpected files in /var/www/html/
rm -f %{buildroot}/var/www/html/apache_pb.gif
rm -f %{buildroot}/var/www/html/apache_pb.png
rm -f %{buildroot}/var/www/html/apache_pb22.gif
rm -f %{buildroot}/var/www/html/apache_pb22.png
rm -f %{buildroot}/var/www/html/apache_pb22_ani.gif
rm -f %{buildroot}/var/www/html/index.html

%pre
# Add the "apache" user
/usr/sbin/useradd -c "Apache" -u 48 \
	-s /sbin/nologin -r -d %{contentdir} apache 2> /dev/null || :

%triggerpostun -- apache < 2.0, stronghold-apache < 2.0
/sbin/chkconfig --add httpd

# Prevent removal of index.html on upgrades from 1.3
%triggerun -- apache < 2.0, stronghold-apache < 2.0
if [ -r %{contentdir}/index.html -a ! -r %{contentdir}/index.html.rpmold ]; then
  mv %{contentdir}/index.html %{contentdir}/index.html.rpmold
fi

%post
# Register the httpd service
/sbin/chkconfig --add httpd

%preun
if [ $1 = 0 ]; then
	/sbin/service httpd stop > /dev/null 2>&1
	/sbin/chkconfig --del httpd
fi

%define sslcert %{_sysconfdir}/pki/tls/certs/localhost.crt
%define sslkey %{_sysconfdir}/pki/tls/private/localhost.key

%post -n mod_ssl
umask 077

if [ ! -f %{sslkey} ] ; then
%{_bindir}/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %{sslkey} 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %{sslcert} ] ; then
cat << EOF | %{_bindir}/openssl req -new -key %{sslkey} \
         -x509 -days 365 -set_serial $RANDOM \
         -out %{sslcert} 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

%check
# Check the built modules are all PIC
if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   : modules contain non-relocatable code
   exit 1
fi

# Verify that the same modules were built into the httpd binaries
./prefork/httpd -l | grep -v prefork > prefork.mods
for mpm in worker; do
  ./${mpm}/httpd -l | grep -v ${mpm} > ${mpm}.mods
  if ! diff -u prefork.mods ${mpm}.mods; then
    : Different modules built into httpd binaries, will not proceed
    exit 1
  fi
done

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)

%doc ABOUT_APACHE README CHANGES LICENSE VERSIONING NOTICE
%doc migration.html migration.css

%dir %{_sysconfdir}/httpd
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/run
%dir %{_sysconfdir}/httpd/conf
%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/welcome.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/proxy_ajp.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_proxy.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_cache.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_dav.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mod_ldap.conf.dist
%config(noreplace) %{_sysconfdir}/httpd/conf/magic

%config(noreplace) %{_sysconfdir}/logrotate.d/httpd
%config %{_sysconfdir}/init.d/httpd

%dir %{_sysconfdir}/httpd/conf.d
%{_sysconfdir}/httpd/conf.d/README

%config(noreplace) %{_sysconfdir}/sysconfig/httpd

%{_bindir}/*
%{_sbindir}/ht*
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%attr(4510,root,%{suexec_caller_group}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so

%dir %{contentdir}
%dir %{contentdir}/cgi-bin
%dir %{contentdir}/html
%dir %{contentdir}/icons
%dir %{contentdir}/error
%dir %{contentdir}/error/include
%dir %{contentdir}/error/styles
%{contentdir}/icons/*
%{contentdir}/error/ErrorCode
%{contentdir}/error/README*
%{contentdir}/error/noindex.html
%config %{contentdir}/error/*.var
%config %{contentdir}/error/include/*.html
%config %{contentdir}/error/styles/*.css

%attr(0700,root,root) %dir %{_localstatedir}/log/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/lib/dav
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/mod_proxy

%{_mandir}/man?/*
%exclude %{_mandir}/man8/apxs.8*

%files manual
%defattr(-,root,root)
%{contentdir}/manual
%config %{_sysconfdir}/httpd/conf.d/manual.conf.dist

%files -n mod_ssl
%defattr(-,root,root)
%{_libdir}/httpd/modules/mod_ssl.so
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf.dist
%attr(0700,apache,root) %dir %{_localstatedir}/cache/mod_ssl
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.dir
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.pag
%attr(0600,apache,root) %ghost %{_localstatedir}/cache/mod_ssl/scache.sem

%files devel
%defattr(-,root,root)
%{_includedir}/httpd
%{_sysconfdir}/httpd/build
%{_sbindir}/apxs
%{_mandir}/man8/apxs.8*
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh

%changelog
* Thu Oct  8 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.14-1m)
- [SECURITY] CVE-2009-3094 CVE-2009-3095
- update to 2.2.14 for mo6plus

* Fri Jul 10 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-6m)
- [SECURITY] CVE-2009-1191 CVE-2009-1195 CVE-2009-1890 CVE-2009-1891
- import upstream patches (Patch70-73)

* Tue May 26 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-5m)
- rebuild against apr-util-1.3.4
-- http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=521899

* Sat May  9 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-4m)
- noreplace %%{_sysconfdir}/httpd/conf/httpd.conf

* Tue Apr 07 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-3m)
- rebuild against openssl-0.9.8k

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-2m)
- rebuild against rpm-4.6

* Tue Jan 13 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (2.2.11-1m)
- update to 2.2.11
-- update Patch21,24 for fuzz=0

* Tue Oct 21 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.10-1m)
- update to 2.2.10
- includes CVE-2008-2939 fixes

* Fri Aug  8 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.9-2m)
- [SECURITY] CVE-2008-2939

* Sun Jun 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.9-1m)
- update to 2.2.9
- this release includes CVE-2008-2364 and CVE-2007-6420 fixes
- remove unused patches

* Fri Jun 13 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.8-6m)
- [SECURITY] CVE-2008-2364, http://svn.apache.org/viewvc/httpd/httpd/trunk/modules/proxy/mod_proxy_http.c?r1=666154&r2=666153&pathrev=666154&view=patch

* Thu Jun  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.8-5m)
- rebuild against openssl-0.9.8h-1m

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.2.8-4m)
- rebuild against gcc43

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (2.2.8-3m)
- %%NoSource -> NoSource

* Sat Feb  2 2008 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2.2.8-1m)
- rebuild against perl-5.10.0-1m

* Thu Jan 24 2008 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (2.2.8-1m)
- up to 2.2.8
- [SECURITY] 	CVE-2007-5000 CVE-2007-6388 CVE-2007-6421 CVE-2007-6422 CVE-2008-0005
- http://www.mindedsecurity.com/MSA01150108.html 

* Tue Sep 11 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.2.6-1m)
- up to 2.2.6
- [SECURITY] CVE-2007-3847 CVE-2007-1863 CVE-2007-3304 CVE-2006-5752

* Tue Jun 12 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.2.4-3m)
- [SECURITY] CVE-2007-1862

* Sat Jun  2 2007 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.2.4-2m)
- rebuild

* Wed Jan 24 2007 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (2.2.4-1m)
- version up 2.2.4
- modify patch50,60 for 2.2.4

* Wed Nov 22 2006 NARITA Koichi <pulsar@momonga-linux.org>
- (2.2.3-5m)
- rebuild against db4-4.5.20-2m

* Thu Nov  2 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (2.2.3-4m)
- enable lib64

* Sun Oct 29 2006 Nishio Futoshi <futoshi@momonga-linux.org>
- (2.2.3-3m)
- use config.layout (--enable-layout=Momonga) for autoconf-2.60

* Sun Aug 27 2006 NARITA Koichi <pulsar@sea.plala.or.jp>
- (2.2.3-2m)
- rebuild against expat-2.0.0-1m

* Fri Jul 28 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.2.3-1m)
- update 2.2.3

* Wed May  3 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.2.2-1m)
- update 2.2.2
- based on fc-devel

* Wed Jan 25 2006 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.55-4m)
- [SECURITY] CVE-2005-3357 CVE-2005-3352

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.55-3m)
- rebuild against openldap-2.3.11

* Mon Jan  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.55-2m)
- rebuild against db4.3

* Wed Oct 19 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.55-1m)
- up to 2.0.55
- fix CAN-2005-2700 CAN-2005-2088 CAN-2005-2728 CAN-2005-1268

* Thu May 12 2005 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.54-3m)
- revise apr-config.in for large file support.

* Sat Apr 23 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.54-2m)
- modify httpd-devel files include /etc/httpd/build

* Tue Apr 19 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.54-1m)
- *) Remove formatting characters from ap_log_error() calls.  These
     were escaped as fallout from CAN-2003-0020.

* Thu Apr  7 2005 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.53-3m)
- remove duplicated files

* Mon Feb 28 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.53-2m)
- no recreate png

* Tue Feb  8 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.53-1m)
- up to 2.0.53. large file support.

* Tue Feb  8 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (2.0.52-7m)
- enable specopt for suexec

* Sun Feb 06 2005 mutecat <mutecat@momonga-linux.org>
- (2.0.52-6m)
- link correction pcreposix.h

* Sun Jan 16 2005 Toru Hoshina <t@momonga-linux.org>
- (2.0.52-5m)
- enable x86_64.

* Sun Nov 28 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.52-4m)
- sync STABLE_1
  * Wed Oct 27 2004 YAMAZAKI Makoto <zaki@zakky.org>
  - (2.0.50-7m)
  - indicated the location of db4 explicitly in order to be
    correctly linked with db4.
    
  * Fri Oct  1 2004 KOMATSU Shinichiro <koma2@momonga-linux.org>
  - (2.0.50-6m)
  - apply the patches to fix CAN-2004-0747, CAN-2004-0748,
    CAN-2004-0751, CAN-2004-0786, CAN-2004-0809
  - change dist site to archive.apache.org
  - README.confd was listed twice, so remove one.

* Fri Nov 12 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.52-3m)
- security fix (CAN-2004-0942)

* Mon Oct 18 2004 Shigeyuki Yamashita <shige@momonga-linux.org>
- (2.0.52-2m)
- security fix (CAN-2004-0885)
  reference -> http://cve.mitre.org/cgi-bin/cvename.cgi?name=CAN-2004-0885
  patch92

* Thu Sep 30 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.52-1m)
- security fix (CAN-2004-0811)
- remove 'httpd-2.0.48-suexeclibs.patch' that was merged

* Mon Sep 27 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.51-2m)
- apply 'CAN-2004-0811.patch'

* Thu Sep 16 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.51-1m)
- including security fixes

* Sun Jul 25 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.50-4m)
- seperate mod_proxy.conf/mod_dav.conf/manual.conf

* Wed Jul 21 2004 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.0.50-3m)
- modify httpd.conf (gif -> png, AddDefaultCharset UTF-8 -> Off)

* Sun Jul 18 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.50-2m)
- import patch from FC2

* Tue Jun 29 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.50-1m)
- including security fixes

* Tue Jun 29 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-8m)
- apply 'CAN-2004-0493.patch'

* Mon Jun 28 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-7m)
- rebuild against db4.2

* Sat May 22 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.49-6m)
- adapt specopt suexec_caller_user and suexec_caller_group value
  requested by [Momonga-devel.ja:02526]

* Fri May 21 2004 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (2.0.49-5m)
- work around sig HUP problem with PHP
- add LoadModule for PHP

* Fri May  7 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.49-4m)
- revise ssl.conf
- use /dev/urandom instead of /dev/random

* Tue May  4 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.49-3m)
- %%{_initscriptdir}

* Fri Apr 16 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.49-2m)
- add --with-berleley-db to configure options

* Sun Mar 21 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.49-1m)
- including security fixes

* Sun Mar 21 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.48-8m)
- modoshisugi.

* Sat Mar 20 2004 Toru Hoshina <t@momonga-linux.org>
- (2.0.48-7m)
- revised spec for enabling rpm 4.2.

* Tue Mar  2 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.48-6m)
- enable SSL_EXPERIMENTAL

* Sun Feb 22 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-5m)
- make both prefork mpm version and worker mpm version

* Sun Feb 22 2004 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-4m)
- now build with '--with-mpm=worker'

* Mon Nov 10 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.48-3m)
- rebuild against gdbm-1.8.0

* Sat Nov  1 2003 YAMAZAKI Makoto <zaki@zakky.org>
- (2.0.48-2m)
- revise httpd.conf to prohibit DocumentRoot directory listing
    see http://www.st.ryukoku.ac.jp/~kjm/security/ml-archive/bugtraq/2003.10/msg00281.html

* Tue Oct 28 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.48-1m)
- security fixes

* Mon Oct 27 2003 zunda <zunda at freeshell.org>
- (2.0.47-5m)
- [Momonga-devel.ja:02161] ssl.conf seems to require to be read before
  php.conf or ruby.conf: /etc/httpd/conf.d/ssl.conf is renamed to
  /etc/httpd/conf.d/00ssl.conf. server/config.c takes care of sorting
  filenames alphanumerically in ap_process_resource_config(), right?

* Sat Oct 04 2003 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.0.47-4m)
- change License: to Apache
- adapt the License: preamble for the Momonga Linux license
  expression unification policy (draft)

* Wed Jul 30 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.47-3m)
- add 'mod_limitipconn-0.22/apachesrc.diff'
- http://dominia.org/djao/limitipconn2.html

* Mon Jul 28 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.47-2m)
- modify certs dir

* Wed Jul  9 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.47-1m)
- security fixes

* Thu Jun 19 2003 Tsuromu Yasuda <tom@tom.homelinux.org>
- (2.0.46-4m)
  fix apr-config (installbuilddir)

* Sun Jun 15 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2.0.46-3m)
- with installbuilddir

* Mon Jun  9 2003 Shigeyuki Yamashita <shige@cty-net.ne.jp>
- (2.0.46-2m)
- error message's styles directory moved
   from "%{contentdir}/html/styles" to "%{contentdir}/errors/styles".

* Wed May 28 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.46-1m)
- security fixes

* Sun May 18 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.0.45-5m)
- export _POSIX2_VERSION=199209 in %%prep section

* Thu May  1 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-4m)
  separated apr

* Sat Apr 26 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-3m)
  added apr and apr-util to devel

* Tue Apr 22 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.45-2m)
  fix requires.
  fix symlink.

* Tue Apr  1 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.45-1m)
- minor security fixes

* Sun Mar 30 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (2.0.44-8m)
- specoptize

* Sun Mar 16 2003 Shigeyuki Yamashita <shige@cty-net.ne.jp>
- (2.0.44-7m)
- add japanize error messages and error page's style.

* Sat Mar  8 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2.0.44-6m)
  rebuild against openssl 0.9.7a

* Mon Feb 17 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.44-5m)
- keep permission of /usr/sbin/suexec

* Mon Feb 17 2003 smbd <smbd.homelinux.org>
- (2.0.44-4m)
- fix mistake (delete powerdby.png)

* Mon Feb 17 2003 smbd <smbd.homelinux.org>
- (2.0.44-3m)
- make png transport and delete gif icons

* Fri Feb 14 2003 Kazuhiko <kazuhiko@fdiary.net>
- (2.0.44-2m)
- revise %files

* Fri Feb 14 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.44-1m)
- upgrade to 2.0.44
- add configure option --with-ldap --enable-ldap --enable-auth-ldap

* Thu Jan 16 2003 Masahiro Takahata <takahata@momonga-linux.org>
- (2.0.43-1m)
- import from rawhide and update to 2.0.43

* Fri Jan  3 2003 Joe Orton <jorton@redhat.com> 2.0.40-15
- fix possible infinite recursion in config dir processing (#77206)
- fix memory leaks in request body processing (#79282)

* Thu Dec 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-14
- remove unstable shmht session cache from mod_ssl
- get SSL libs from pkg-config if available (Nalin Dahyabhai)
- stop "apxs -a -i" from inserting AddModule into httpd.conf (#78676)

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-13
- fix location of installbuilddir in apxs when libdir!=/usr/lib

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-12
- pass libdir to configure; clean up config_vars.mk
- package instdso.sh, fixing apxs -i (#73428)
- prevent build if upstream MMN differs from mmn macro
- remove installed but unpackaged files

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-11
- correct SERVER_NAME encoding in i18n error pages (thanks to Andre Malo)

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-10
- fix patch for CAN-2002-0840 to also cover i18n error pages

* Wed Oct  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-9
- security fixes for CAN-2002-0840 and CAN-2002-0843
- fix for possible mod_dav segfault for certain requests

* Tue Sep 24 2002 Gary Benson <gbenson@redhat.com>
- updates to the migration guide

* Wed Sep  4 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.40-8
- link httpd with libssl to avoid library loading/unloading weirdness

* Tue Sep  3 2002 Joe Orton <jorton@redhat.com> 2.0.40-7
- add LoadModule lines for proxy modules in httpd.conf (#73349)
- fix permissions of conf/ssl.*/ directories; add Makefiles for
  certificate management (#73352)

* Mon Sep  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-6
- provide "httpd-mmn" to manage module ABI compatibility

* Sun Sep  1 2002 Joe Orton <jorton@redhat.com> 2.0.40-5
- fix SSL session cache (#69699)
- revert addition of LDAP support to apr-util

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-4
- set SIGXFSZ disposition to "ignored" (#69520)
- make dummy connections to the first listener in config (#72692)

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-3
- allow "apachectl configtest" on a 1.3 httpd.conf
- add mod_deflate
- enable LDAP support in apr-util
- don't package everything in /var/www/error as config(noreplace)

* Wed Aug 21 2002 Bill Nottingham <notting@redhat.com> 2.0.40-2
- add trigger (#68657)

* Mon Aug 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-1
- update to 2.0.40

* Wed Jul 24 2002 Joe Orton <jorton@redhat.com> 2.0.36-8
- improve comment on use of UserDir in default config (#66886)

* Wed Jul 10 2002 Joe Orton <jorton@redhat.com> 2.0.36-7
- use /sbin/nologin as shell for apache user (#68371)
- add patch from CVS to fix possible infinite loop when processing
  internal redirects

* Wed Jun 26 2002 Gary Benson <gbenson@redhat.com> 2.0.36-6
- modify init script to detect 1.3.x httpd.conf's and direct users
  to the migration guide

* Tue Jun 25 2002 Gary Benson <gbenson@redhat.com> 2.0.36-5
- patch apachectl to detect 1.3.x httpd.conf's and direct users
  to the migration guide
- ship the migration guide

* Fri Jun 21 2002 Joe Orton <jorton@redhat.com>
- move /etc/httpd2 back to /etc/httpd
- add noindex.html page and poweredby logo; tweak default config
  to load noindex.html if no default "/" page is present.
- add patch to prevent mutex errors on graceful restart

* Fri Jun 21 2002 Tim Powers <timp@redhat.com> 2.0.36-4
- automated rebuild

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-3
- add patch to fix SSL mutex handling

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-2
- improved config directory patch

* Mon May 20 2002 Joe Orton <jorton@redhat.com>
- initial build; based heavily on apache.spec and mod_ssl.spec
- fixes: #65214, #58490, #57376, #61265, #65518, #58177, #57245
